Subject: Re: [PATCH] allow dctcp alpha to drop to zero

From: Florian Westphal <[email-masked]>
Date: Mon, 19 Oct 2015 16:01:35 +0200

Andrew Shewmaker <[email-masked]> wrote:
> If alpha is strictly reduced by alpha >> dctcp_shift_g and if alpha is less
> than 1 << dctcp_shift_g, then alpha may never reach zero. For example,
> given shift_g=4 and alpha=15, alpha >> dctcp_shift_g yields 0 and alpha
> remains 15. The effect isn't noticeable in this case below cwnd=137, but
> could gradually drive uncongested flows with leftover alpha down to
> cwnd=137. A larger dctcp_shift_g would have a greater effect.
> 
> This change causes alpha=15 to drop to 0 instead of being decrementing by 1
> as it would when alpha=16. However, it requires one less conditional to
> implement since it doesn't have to guard against subtracting 1 from 0U. A
> decay of 15 is not unreasonable since an equal or greater amount occurs at
> alpha >= 240.
> 
> Signed-off-by: Andrew G. Shewmaker <[email-masked]>

Acked-by: Florian Westphal <[email-masked]>

[ cwnd=137 is quite large so I don't think its important enough for
-stable ].